Subject: Re: [diameter] RE: [AAA-WG]: Re: questions and comments regarding the Diameter A PI draft

From: David Frascone <[email-masked]>
Date: Wed, 2 May 2001 15:04:13 -0500

On Wed, May 02, 2001 at 03:27:17PM -0400, Yiwen Jiang wrote:
> > That is assumed to be handled internally. -- In other words, 
> > when you do
> > an AAARespondToMessage(), it massages the current message 
> > from incoming
> > to outgoing, and allows you to modify fields.
> Okay, but how does one modify the fields, since upon return of this
> function, the message is already sent? For example, what happens if the
> server decides to add more AVPs onto the response message? The
> AAAResponseMessage() does not provide a mean for the server to add or delete
> AVPs from itself before sending the modified message. I thought the response
> message is created by AAANewMessage, with the request message as the last
> parameter?  If the AAAResponseToMessage() is to be kept this way, can we
> have some detailed description of what it does in the ID then?
> 

Ahhh, now I see your confusion.  AAARespondToMessage does NOT send the
message, but sets all the flags to mart it as a response, and sets the 
internal destination/etc so that it will be routed back to the sender.

So, you would call AAARespondToMessage(), manipulate the AVPs, then do an
AAASendMessage() to send the message.  

Clearer?

---

From: Yiwen Jiang <[email-masked]>
Date: Wed, 2 May 2001 15:27:17 -0400

Hi Dave,

> I don't think so.  We might want to mention that a server 
> *might* handle 
> DRI's itself, but that is kind of implementation specific.  
> Remember, we're
> not designing a server here, just an API to do AAA work.  If "Bob's
> AAA Server" decides to allow applications to register for DRI's, that
> is Bob's perrogative.
Agreed.
 
> > > > 	+ Sec. 3.4.5.3, Pg. 29. When would I use the 
> > > AAARespondToMessage()?
> > > > Can't I just do:
> > > > 	  AAANewMessage();
> > > > 	  AAASetServer();
> > > > 	  AAASendMessage();
> >  > 
> > > Yes, but AAARespondToMessage will set the flags right (indicating a
> > > response), and will include any Proxy-State type information that
> > > the application shouldn't have to mess with.
> > But the signature of AAARespondToMessage, it only contains 
> one reference to
> > the message to respond to... To set  these information 
> correctly, wouldn't
> > you need to have another AAAMessage somewhere in the 
> signature for the
> > respond message?
>